;********************************************************************************************
;********************************************************************************************
;
;	ROUTINES PER LA GESTIONE DEI TASTI, SPECIFICHE PER "PIC18FXXX"
;	Versione 1.3		     Ult.agg. 28/10/03
;
;********************************************************************************************

;****************************************************************************
;----------------------------------------------------------------------------
;	I TASTI DEVONO AVERE "PULL-UP" ED ESSERE NORMALMENTEAPERTI 
;----------------------------------------------------------------------------
;	I TASTI DA UTILIZZARE DEVONO ESSERE DEFINITI SOTTO.
;	QUANDO UN TASTO VIENE PREMUTO VIENE CHIAMATA 
;	L'APPOSITA ROUTINE DI DECODIFICA.
;
;	I TASTI DEVONO AVERE PULL-UP ED ESSERE NORMALMENTE APERTI!
;	UTILIZZO: INSERIRE LA ROUTINE "WAITFORKEY" NEL LOOP PRINCIPALE (POLLING)
;
;	INOTRE DEVONO ESSERE DEFINITE LE SUBROUTINE "KEY_N_Routine"
;	CHE VENGONO CHIAMATE ALLA PRESSIONE DEL TASTO "KEY_n"...
;	...E LE SUBROUTINE "KEY_N_POST_Routine"
;	CHE VENGONO CHIAMATE AL RILASCIO DEL TASTO "KEY_n".
;
;****************************************************************************

;-----	HARDWARE SETTING  -------------------------------------

#UNDEFINE	KEY_0	0	; Corrisponde al bit della porta scelta
#UNDEFINE 	KEY_1	1	;
#DEFINE 	KEY_2	2	;
#DEFINE 	KEY_3	3	;
#UNDEFINE 	KEY_4	4	;
#UNDEFINE 	KEY_5	5	;
#UNDEFINE 	KEY_6	6	;
#UNDEFINE 	KEY_7	7	;

PORT_KEY	=	PORTC	; Porta utilizzata per i tasti
PORT_KEY_TRIS	=	TRISC	;

;-----	SOFTWARE SETTING  -------------------------------------

#UNDEFINE KEYS_RETURN		; ABILITAZIONE RILASCIO TASTO
#DEFINE SPEED_KEYS_ON		; ABILITAZIONE TASTI VELOCI
#DEFINE KEY_PRESSING		; ABILITAZIONE TASTO TENUTO PREMUTO (Tasto MonoVeloce)
#UNDEFINE SPEED_KEYS_RETURN	; ABILITAZIONE RILASCIO TASTO DA TASTI VELOCI

; NOTA:	Se  incluso il file "18fmacro" tutti i tempi sono reali, 
;	se invece il file  non  incluso i tempi si riferiscono a 4 MPS
;
#DEFINE ANTIRIMB_MS	.50	; (ms) per antirimbalzo 
#DEFINE WAIT_SPEED	.20	; (ms * ANTIRIMB_MS) attesa per ripetizione tasto
#DEFINE SPEED		.50	; (ms) tempo di ripetizione tasto


;*** REGISTRI DA DEFINIRE NEL MAIN PROGRAM!  ***;
;	KEY		EQU	...		;
;	TEMP_KEY	EQU	...		;
;	TEMP_KEY2	EQU	...		;
;	TEMP_KEY3	EQU	...		;
;***  DA DEFINIRE!  ****************************;
;KEY_0_Routine					;
;KEY_1_Routine					;
;KEY_2_Routine					;
;KEY_3_Routine					;
;KEY_4_Routine					;
;KEY_5_Routine					;
;KEY_6_Routine					;
;KEY_7_Routine					;
;KEY_0_PRESS_Routine				;
;KEY_1_PRESS_Routine				;
;KEY_2_PRESS_Routine				;
;KEY_3_PRESS_Routine				;
;KEY_4_PRESS_Routine				;
;KEY_5_PRESS_Routine				;
;KEY_6_PRESS_Routine				;
;KEY_7_PRESS_Routine				;
;KEY_0_POST_Routine				;
;KEY_1_POST_Routine				;
;KEY_2_POST_Routine				;
;KEY_3_POST_Routine				;
;KEY_4_POST_Routine				;
;KEY_5_POST_Routine				;
;KEY_6_POST_Routine				;
;KEY_7_POST_Routine				;
;KEY_0_POST_PRESS_Routine			;
;KEY_1_POST_PRESS_Routine			;
;KEY_2_POST_PRESS_Routine			;
;KEY_3_POST_PRESS_Routine			;
;KEY_4_POST_PRESS_Routine			;
;KEY_5_POST_PRESS_Routine			;
;KEY_6_POST_PRESS_Routine			;
;KEY_7_POST_PRESS_Routine			;
		RETURN				;
;*******************************************************************************;
;										;
;	NOTA:									;
;	KEY_x_Routine: Chiamata alla pressione del tasto			;
;	KEY_x_POST_Routine: Chiamata al rilascio del tasto			;
;	KEY_x_PRESS_Routine: Chiamata se il tasto viene TENUTO premuto		;
;	KEY_x_POST_PRESS_Routine: Chiamata al rilascio del tasto tenuto permuto	;
;										;
;*******************************************************************************;

;****************************************************************************;
;	MASK_KEY = B'XXXXXXXX'	; AD OGNI "1" CORRISPONDE UN TASTO
;	Viene calcolata in automatico ... DO NOT TOUCH!
;****************************************************************************
variable	MASK_KEY = B'00000000'

	IFDEF	KEY_0
	MASK_KEY = MASK_KEY | B'00000001'
	ENDIF
	IFDEF	KEY_1
	MASK_KEY = MASK_KEY | B'00000010'
	ENDIF
	IFDEF	KEY_2
	MASK_KEY = MASK_KEY | B'00000100'
	ENDIF
	IFDEF	KEY_3
	MASK_KEY = MASK_KEY | B'00001000'
	ENDIF
	IFDEF	KEY_4
	MASK_KEY = MASK_KEY | B'00010000'
	ENDIF
	IFDEF	KEY_5
	MASK_KEY = MASK_KEY | B'00100000'
	ENDIF
	IFDEF	KEY_6
	MASK_KEY = MASK_KEY | B'01000000'
	ENDIF
	IFDEF	KEY_7
	MASK_KEY = MASK_KEY | B'10000000'
	ENDIF


;****************************************************************************
;****************************************************************************
;
;	ROUTINE DI INIZIALIZZAZIONE HARDWARE DEI TASTI
;
;****************************************************************************
;****************************************************************************

INIT_KEYS
IFDEF	KEY_0
	BSF	PORT_KEY_TRIS,KEY_0 
ENDIF
IFDEF	KEY_1
	BSF	PORT_KEY_TRIS,KEY_1 
ENDIF
IFDEF	KEY_2
	BSF	PORT_KEY_TRIS,KEY_2 
ENDIF
IFDEF	KEY_3
	BSF	PORT_KEY_TRIS,KEY_3 
ENDIF
IFDEF	KEY_4
	BSF	PORT_KEY_TRIS,KEY_4 
ENDIF
IFDEF	KEY_5
	BSF	PORT_KEY_TRIS,KEY_5 
ENDIF
IFDEF	KEY_6
	BSF	PORT_KEY_TRIS,KEY_6
ENDIF
IFDEF	KEY_7
	BSF	PORT_KEY_TRIS,KEY_7 
ENDIF
	RETURN



;****************************************************************************
;****************************************************************************
;
;	ROUTINE PRINCIPALE DI POLLING
;
;****************************************************************************
;****************************************************************************

WAITFORKEY
	movf	PORT_KEY, W	;
	movwf	KEY		;
	comf	KEY, W		;
	andlw   MASK_KEY	;
	movwf   KEY		;
	movf	KEY, F		;
	btfsc   STATUS, Z	;
	return			;

	CALL	KEY_DECODE	;

IFDEF	SPEED_KEYS_ON
	MOVLW	WAIT_SPEED	;; SETTING ATTESA PER TASTI VELOCI
	MOVWF	TEMP_KEY2	;;
ENDIF
	
wfP	CALL	ANTI_RIMB	;; ATTESA ANTIRIMBALZO

IFDEF	SPEED_KEYS_ON
	DECFSZ	TEMP_KEY2	;;
	GOTO	xxx		;;
	GOTO	SPEEDKEY	;;
ENDIF
				
xxx	movf    PORT_KEY, W	;
	movwf	TEMP_KEY	;
	comf	TEMP_KEY, W	;
	andlw   MASK_KEY	;
	movwf   TEMP_KEY	;
	movf	TEMP_KEY, F	;
	btfss   STATUS, Z	;
	goto    wfP		;

IFDEF	KEYS_RETURN
	CALL	KEY_POST_DECODE
ENDIF
	CALL	ANTI_RIMB	;; ATTESA ANTIRIMBALZO
	return


IFDEF	SPEED_KEYS_ON
SPEEDKEY
	CALL	KEY_PRESS_DECODE	;;
MONO_SPEEDKEY
	MOVLW	SPEED			;; QUESTO NUMERO DETERMINA LA VELOCITA' 
	MOVWF	TEMP_KEY2		;; DELL'AVANZAMENTO VELOCE

yyy	CALL	MILLISEC		;;
	DECFSZ	TEMP_KEY2		;;
	GOTO	yyy			;;

	movf    PORT_KEY,  W		;;
	movwf	TEMP_KEY		;;
	comf	TEMP_KEY, W		;;
	andlw   MASK_KEY		;;
	movwf   TEMP_KEY		;;
	movf	TEMP_KEY, F		;;
	btfss   STATUS, Z		;;
	
	IFNDEF	KEY_PRESSING		;;
	goto    SPEEDKEY		;;
	ENDIF				;;
	IFDEF	KEY_PRESSING		;;
	goto    MONO_SPEEDKEY		;;
	ENDIF				;;
	IFDEF	SPEED_KEYS_RETURN	;;
	CALL	KEY_POST_PRESS_DECODE	;;
	ENDIF				;;
	
	CALL	ANTI_RIMB		;; ATTESA ANTIRIMBALZO
	return
ENDIF

;****************************************************************************
;****************************************************************************
;
;	ROUTINE DI DECODIFICA DEI TASTI
;
;****************************************************************************
;****************************************************************************
IFNDEF MENU_ON

KEY_DECODE

IFDEF	KEY_0
	BTFSC	KEY, KEY_0
	GOTO	KEY_0_Routine
ENDIF
IFDEF	KEY_1
	BTFSC	KEY, KEY_1
	GOTO	KEY_1_Routine
ENDIF
IFDEF	KEY_2
	BTFSC	KEY, KEY_2
	GOTO	KEY_2_Routine
ENDIF
IFDEF	KEY_3
	BTFSC	KEY, KEY_3
	GOTO	KEY_3_Routine
ENDIF
IFDEF	KEY_4
	BTFSC	KEY, KEY_4
	GOTO	KEY_4_Routine
ENDIF
IFDEF	KEY_5
	BTFSC	KEY, KEY_5
	GOTO	KEY_5_Routine
ENDIF
IFDEF	KEY_6
	BTFSC	KEY, KEY_6
	GOTO	KEY_6_Routine
ENDIF
IFDEF	KEY_7
	BTFSC	KEY, KEY_7
	GOTO	KEY_7_Routine
ENDIF
	RETURN


IFDEF	SPEED_KEYS_ON
KEY_PRESS_DECODE

	IFDEF	KEY_0
		BTFSC	KEY, KEY_0
		GOTO	KEY_0_PRESS_Routine
	ENDIF
	IFDEF	KEY_1
		BTFSC	KEY, KEY_1
		GOTO	KEY_1_PRESS_Routine
	ENDIF
	IFDEF	KEY_2
		BTFSC	KEY, KEY_2
		GOTO	KEY_2_PRESS_Routine
	ENDIF
	IFDEF	KEY_3
		BTFSC	KEY, KEY_3
		GOTO	KEY_3_PRESS_Routine
	ENDIF
	IFDEF	KEY_4
		BTFSC	KEY, KEY_4
		GOTO	KEY_4_PRESS_Routine
	ENDIF
	IFDEF	KEY_5
		BTFSC	KEY, KEY_5
		GOTO	KEY_5_PRESS_Routine
	ENDIF
	IFDEF	KEY_6
		BTFSC	KEY, KEY_6
		GOTO	KEY_6_PRESS_Routine
	ENDIF
	IFDEF	KEY_7
		BTFSC	KEY, KEY_7
		GOTO	KEY_7_PRESS_Routine
	ENDIF
		RETURN
ENDIF


IFDEF	KEYS_RETURN
KEY_POST_DECODE

	IFDEF	KEY_0
		BTFSC	KEY, KEY_0
		GOTO	KEY_0_POST_Routine
	ENDIF
	IFDEF	KEY_1
		BTFSC	KEY, KEY_1
		GOTO	KEY_1_POST_Routine
	ENDIF
	IFDEF	KEY_2
		BTFSC	KEY, KEY_2
		GOTO	KEY_2_POST_Routine
	ENDIF
	IFDEF	KEY_3
		BTFSC	KEY, KEY_3
		GOTO	KEY_3_POST_Routine
	ENDIF
	IFDEF	KEY_4
		BTFSC	KEY, KEY_4
		GOTO	KEY_4_POST_Routine
	ENDIF
	IFDEF	KEY_5
		BTFSC	KEY, KEY_5
		GOTO	KEY_5_POST_Routine
	ENDIF
	IFDEF	KEY_6
		BTFSC	KEY, KEY_6
		GOTO	KEY_6_POST_Routine
	ENDIF
	IFDEF	KEY_7
		BTFSC	KEY, KEY_7
		GOTO	KEY_7_POST_Routine
	ENDIF
		RETURN
ENDIF


IFDEF	SPEED_KEYS_ON
IFDEF	SPEED_KEYS_RETURN
	KEY_POST_PRESS_DECODE

	IFDEF	KEY_0
		BTFSC	KEY, KEY_0
		GOTO	KEY_0_POST_PRESS_Routine
	ENDIF
	IFDEF	KEY_1
		BTFSC	KEY, KEY_1
		GOTO	KEY_1_POST_PRESS_Routine
	ENDIF
	IFDEF	KEY_2
		BTFSC	KEY, KEY_2
		GOTO	KEY_2_POST_PRESS_Routine
	ENDIF
	IFDEF	KEY_3
		BTFSC	KEY, KEY_3
		GOTO	KEY_3_POST_PRESS_Routine
	ENDIF
	IFDEF	KEY_4
		BTFSC	KEY, KEY_4
		GOTO	KEY_4_POST_PRESS_Routine
	ENDIF
	IFDEF	KEY_5
		BTFSC	KEY, KEY_5
		GOTO	KEY_5_POST_PRESS_Routine
	ENDIF
	IFDEF	KEY_6
		BTFSC	KEY, KEY_6
		GOTO	KEY_6_POST_PRESS_Routine
	ENDIF
	IFDEF	KEY_7
		BTFSC	KEY, KEY_7
		GOTO	KEY_7_POST_PRESS_Routine
	ENDIF
		RETURN
ENDIF
ENDIF

ENDIF
;****************************************************************************
;****************************************************************************
;
;	RITARDI ANTI RIMBALZO E SCORRIMENTO VELOCE
;
;****************************************************************************
;****************************************************************************

MILLISEC			; CIRCA 1 MILLISECONDO A 4 MPS			
IFNDEF	MICROSECONDI
    movlw   .250
        movwf   TEMP_KEY
arb     clrwdt
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        decfsz  TEMP_KEY, F
        goto    arb
ENDIF
IFDEF	MICROSECONDI
	DelayMilliSec	.1
        return

ANTI_RIMB
	movlw   ANTIRIMB_MS
	movwf   TEMP_KEY3
arb2	call	MILLISEC
	decfsz  TEMP_KEY3, F
        goto    arb2
        return
ENDIF
