;********************************************************************************************
;
;	ROUTINES PER EFFETTUARE IL CONTROLLO DI SERVIMOTORE DA MODELLISMO
;	(HS-81 Microservo) SPECIFICHE PER "PIC18FXXX"
;	Versione 2.1 			     		Ult.agg. 15/07/04
;
;********************************************************************************************

;********************************************************************************************
;
;	NOTA: PER FUNZIONARE LA ROUTINE "SERVO_UPDATE" HA BISGNO DI ESSERE 
;	      CHIAMATA OGNI 20 ms!(Interrup sul modulo CCP timer1)
;	      SONO RICHIESTI INOLTRE L' INCLUDE DEL FILE "f18macro.asm"
;				
;********************************************************************************************

;--- REGISTRI DA DEFINIRE NEL MAIN PROGRAM!  -----------------------------------;
;	FRAME, SERV_TEMP_P1, SERV_TEMP_P2, SERV_TEMP_P3				;
;	VALUE_SERV_P1_0, VALUE_SERV_P1_1, VALUE_SERV_P1_2, VALUE_SERV_P1_3	;
;	VALUE_SERV_P1_4, VALUE_SERV_P1_5, VALUE_SERV_P1_6, VALUE_SERV_P1_7	;
;	VALUE_SERV_P2_0, VALUE_SERV_P2_1, VALUE_SERV_P2_2, VALUE_SERV_P2_3	;
;	VALUE_SERV_P2_4, VALUE_SERV_P2_5, VALUE_SERV_P2_6, VALUE_SERV_P2_7	;
;	VALUE_SERV_P3_0, VALUE_SERV_P3_1, VALUE_SERV_P3_2, VALUE_SERV_P3_3	;
;	VALUE_SERV_P3_4, VALUE_SERV_P3_5, VALUE_SERV_P3_6, VALUE_SERV_P3_7	;
;										;
;	Nota: NON SONO TUTTI NECESSARI ... DIPENDE DALLA CONFIGURAZIONE		;
;										;

;-------------------------------;
; PARAMETRI IMPOSTABILI		;
;-------------------------------;
				;
#DEFINE NUM_OF_SERV_P1	D'8'	; I SERVI DEVONO ESSERE MESSI SU PIN CONSECUTIVI A PARTIRE DA 0. 
#DEFINE	PORT_SERV_P1	PORTB	; DEFINIZIONE PORTA PER I SERVI
#DEFINE	TRIS_SERV_P1	TRISB	;


#DEFINE NUM_OF_SERV_P2	D'4'	; I SERVI DEVONO ESSERE MESSI SU PIN CONSECUTIVI A PARTIRE DA 0
#DEFINE	PORT_SERV_P2	PORTA	; DEFINIZIONE PORTA PER I SERVI
#DEFINE	TRIS_SERV_P2	TRISA	;

#DEFINE NUM_OF_SERV_P3	D'0'	; I SERVI DEVONO ESSERE MESSI SU PIN CONSECUTIVI A PARTIRE DA 0
#DEFINE	PORT_SERV_P3	PORTC	; DEFINIZIONE PORTA PER I SERVI
#DEFINE	TRIS_SERV_P3	TRISC	;

#DEFINE NUM_OF_SERV	(NUM_OF_SERV_P1 + NUM_OF_SERV_P2 + NUM_OF_SERV_P3)	; TOT NUM OF SERVOS



	IF NUM_OF_SERV == 0
	ERROR	"Selezionare almeno un servomotore!"
	ENDIF

	variable NUM_SERVOPORT
	NUM_SERVOPORT = 0

	IF NUM_OF_SERV_P1 > 0
	NUM_SERVOPORT ++
	ENDIF
	IF NUM_OF_SERV_P2 > 0
	NUM_SERVOPORT ++
	ENDIF
	IF NUM_OF_SERV_P3 > 0
	NUM_SERVOPORT ++
	ENDIF

	variable MASK_SERV_P1
	IF NUM_OF_SERV_P1 == 1
		MASK_SERV_P1 = B'00000001'
	ENDIF
	IF NUM_OF_SERV_P1 == 2
		MASK_SERV_P1 = B'00000011'
	ENDIF
	IF NUM_OF_SERV_P1 == 3
		MASK_SERV_P1 = B'00000111'
	ENDIF
	IF NUM_OF_SERV_P1 == 4
		MASK_SERV_P1 = B'00001111'
	ENDIF
	IF NUM_OF_SERV_P1 == 5
		MASK_SERV_P1 = B'00011111'
	ENDIF
	IF NUM_OF_SERV_P1 == 6
		MASK_SERV_P1 = B'00111111'
	ENDIF
	IF NUM_OF_SERV_P1 == 7
		MASK_SERV_P1 = B'01111111'
	ENDIF
	IF NUM_OF_SERV_P1 == 8
		MASK_SERV_P1 = B'11111111'
	ENDIF
	IF NUM_OF_SERV_P1 > 8
	ERROR	"Troppi Servomotori su una Singola Porta!"
	ENDIF

	variable MASK_SERV_P2

	IF NUM_OF_SERV_P2 == 1
		MASK_SERV_P2 = B'00000001'
	ENDIF
	IF NUM_OF_SERV_P2 == 2
		MASK_SERV_P2 = B'00000011'
	ENDIF
	IF NUM_OF_SERV_P2 == 3
		MASK_SERV_P2 = B'00000111'
	ENDIF
	IF NUM_OF_SERV_P2 == 4
		MASK_SERV_P2 = B'00001111'
	ENDIF
	IF NUM_OF_SERV_P2 == 5
		MASK_SERV_P2 = B'00011111'
	ENDIF
	IF NUM_OF_SERV_P2 == 6
		MASK_SERV_P2 = B'00111111'
	ENDIF
	IF NUM_OF_SERV_P2 == 7
		MASK_SERV_P2 = B'01111111'
	ENDIF
	IF NUM_OF_SERV_P2 == 8
		MASK_SERV_P2 = B'11111111'
	ENDIF
	IF NUM_OF_SERV_P2 > 8
	ERROR	"Troppi Servomotori su una Singola Porta!"
	ENDIF

	variable MASK_SERV_P3

	IF NUM_OF_SERV_P3 == 1
		MASK_SERV_P3 = B'00000001'
	ENDIF
	IF NUM_OF_SERV_P3 == 2
		MASK_SERV_P3 = B'00000011'
	ENDIF
	IF NUM_OF_SERV_P3 == 3
		MASK_SERV_P3 = B'00000111'
	ENDIF
	IF NUM_OF_SERV_P3 == 4
		MASK_SERV_P3 = B'00001111'
	ENDIF
	IF NUM_OF_SERV_P3 == 5
		MASK_SERV_P3 = B'00011111'
	ENDIF
	IF NUM_OF_SERV_P3 == 6
		MASK_SERV_P3 = B'00111111'
	ENDIF
	IF NUM_OF_SERV_P3 == 7
		MASK_SERV_P3 = B'01111111'
	ENDIF
	IF NUM_OF_SERV_P3 == 8
		MASK_SERV_P3 = B'11111111'
	ENDIF
	IF NUM_OF_SERV_P3 > 8
	ERROR	"Troppi Servomotori su una Singola Porta!"
	ENDIF

SERVO_INIT
	MOVLW	MASK_SERV_P1	; SELEZIONO I PIN DEI SERVOMOTORI COME OUTPUT
	COMF	WREG, W		;
	ANDWF	TRIS_SERV_P1, F	;
	ANDWF	PORT_SERV_P1, F	;
	MOVLW	MASK_SERV_P2	; SELEZIONO I PIN DEI SERVOMOTORI COME OUTPUT
	COMF	WREG, W		;
	ANDWF	TRIS_SERV_P2, F	;
	ANDWF	PORT_SERV_P2, F	;
	MOVLW	MASK_SERV_P3	; SELEZIONO I PIN DEI SERVOMOTORI COME OUTPUT
	COMF	WREG, W		;
	ANDWF	TRIS_SERV_P3, F	;
	ANDWF	PORT_SERV_P3, F	;
	RETURN

	
;-----------------------------------------------;
;						;
;	MACRO NECESSARIE A SERVLOOP		;
;						;
;-----------------------------------------------;
;	(2 * NUM_OF_SERV) Istruzioni		;
;-----------------------------------------------;
N_Servi	macro					;
	local	a = 0				;
	while	a < NUM_OF_SERV_P1		;
						;
	CPFSGT	VALUE_SERV_P1_#v(a)		; 
	BCF	SERV_TEMP_P1, #v(a)		; 
						;
a ++						;
	endw					;
	local	a = 0				;
	while	a < NUM_OF_SERV_P2		;
						;
	CPFSGT	VALUE_SERV_P2_#v(a)		; 
	BCF	SERV_TEMP_P2, #v(a)		; 
						;
a ++						;
	endw					;
	local	a = 0				;
	while	a < NUM_OF_SERV_P3		;
						;
	CPFSGT	VALUE_SERV_P3_#v(a)		; 
	BCF	SERV_TEMP_P3, #v(a)		; 
						;
a ++						;
	endw					;
	endm					;
;---------------------------------------------------------------------------------------;
;	Il numero di istruzioni in 5 us :						;
;	D'5' * FREQUENCY / D'4000'							;
;	Dunque il numero di nop da inserire :						;
;	(D'5' * FREQUENCY / D'4000') - (D'6' + D'2' * NUM_OF_SERV)			;
;---------------------------------------------------------------------------------------;
N_Nop	macro										;
	variable NomNumFix								;
	variable MinInstr								;
	MinInstr = (D'4'+ (2 * NUM_SERVOPORT))						;
	NomNumFix = (D'5' * FREQUENCY / D'4000') - (MinInstr + D'2' * NUM_OF_SERV)	;
	if	(D'5' * FREQUENCY / D'4000') < (MinInstr + D'2' * NUM_OF_SERV)		;
	error "La frequenza  troppo bassa per pilotare tutti i servimotore!"		;
	endif										;
	if	((D'5' * FREQUENCY) % D'4000') != 0					;
	messg "Il controllo dei servi NON sar esatto, causa frequenza sistema"		;
	endif										;
	local	nopnum = 0								;
	while	nopnum < NomNumFix							;
	NOP										;
	nopnum ++									;
	endw										;
	endm										;
;---------------------------------------------------------------------------------------;


SERVO_UPDATE
	CLRF	FRAME		; ALZO SOLO I PIN DEI SERVI ATTIVI
	SETF	SERV_TEMP_P1	;
	SETF	SERV_TEMP_P2	;
	SETF	SERV_TEMP_P3	;
IF	NUM_OF_SERV_P1 > 0
	MOVLW	MASK_SERV_P1	; COSI' AGISCO SOLO SUI PIN EFFETTIVAMENTE
	IORWF	PORT_SERV_P1, F	; COLLEGATI AD UN SERVO!
ENDIF
IF	NUM_OF_SERV_P2 > 0
	MOVLW	MASK_SERV_P2	; COSI' AGISCO SOLO SUI PIN EFFETTIVAMENTE
	IORWF	PORT_SERV_P2, F	; COLLEGATI AD UN SERVO!
ENDIF
IF	NUM_OF_SERV_P3 > 0
	MOVLW	MASK_SERV_P3	; COSI' AGISCO SOLO SUI PIN EFFETTIVAMENTE
	IORWF	PORT_SERV_P3, F	; COLLEGATI AD UN SERVO!
ENDIF
		
	DelayMicroSec	D'860'	; 0.860 ms DI ATTESA (per utilizzare tutti i bit ... 
				; ... vado leggermente fuori le specifiche del servo)

SERVLOOP			; IL LOOP, ESCLUSI I NOP, E' DI (2 * NUM_OF_SERV + 2 * NUM_SERVOPORT + 4) ISTRUZIONI
	MOVF	FRAME, W	; E DEVE DURARE ESATTAMENTE 5 us

	N_Servi			; La macro occupa (2 * NUM_OF_SERV) Istruzioni.
	N_Nop			; Sono aggiunti tanti NOP quanti ne servono perch 
				; la routine SERVLOOP duri esattamente 5 us!
				
				;-----------------------------------------------
	IF NUM_OF_SERV_P1 > 0
	MOVF	SERV_TEMP_P1, W	; COSI' AGISCO SOLO SUI PIN EFFETTIVAMENTE	
	ANDWF	PORT_SERV_P1, F	; COLLEGATI AD UN SERVO!
	ENDIF
	IF NUM_OF_SERV_P2 > 0
	MOVF	SERV_TEMP_P2, W	; COSI' AGISCO SOLO SUI PIN EFFETTIVAMENTE	
	ANDWF	PORT_SERV_P2, F	; COLLEGATI AD UN SERVO!
	ENDIF
	IF NUM_OF_SERV_P3 > 0
	MOVF	SERV_TEMP_P3, W	; COSI' AGISCO SOLO SUI PIN EFFETTIVAMENTE	
	ANDWF	PORT_SERV_P3, F	; COLLEGATI AD UN SERVO!
	ENDIF

	INCFSZ	FRAME, F	; 
	GOTO	SERVLOOP	; QUANDO HO FATTO TUTTI I FRAME POSSO USCIRE	
	RETURN			;-----------------------------------------------
