;***************************************************************************************;
;											;
;	Firmware for Servo Motor Control						;
;											;
;	Author:	VIRGILIO MATTOLI		MAY-08-2005 (Version 3.0.1)		;
;	Frequency = 40 MHz di clock (10MHz x 4PLL)					;
;											;
;***************************************************************************************;


	LIST P = 18F252			; 
	include <P18F252.inc>		; 
					; La routine e' per i 40 MHz di clock (10MHz x 4PLL)--> 4MP/s
	#define FREQUENCY D'40000'	; Frequenza del procesore in KHz (va considerato anche l'eventuale PLL)

        include "18fXX2_conf.h"	;	

	CBLOCK 0x15
        TEMP, TEMP1, TEMP2, TEMP3 

	TIME_STEP_H, TIME_STEP_L 
	TOT_NUM_STEP_H, TOT_NUM_STEP_L, PAGE_COUNTER	; TOT_NUM_STEP == NUM OF BYTE!!! PROVVISORIO ...
	STEP_COUNTER_H, STEP_COUNTER_L			; STEP_COUNTER == ACTUAL STEP INDEX!!!
	CINQUANTESIMI, QUARTI, SECONDI, MINUTI		;

	FRAME, SERV_TEMP_P1, SERV_TEMP_P2, SERV_TEMP_P3					

	VALUE_SERV_P1_0, VALUE_SERV_P1_1, VALUE_SERV_P1_2, VALUE_SERV_P1_3	;
	VALUE_SERV_P1_4, VALUE_SERV_P1_5, VALUE_SERV_P1_6, VALUE_SERV_P1_7	;
	VALUE_SERV_P2_0, VALUE_SERV_P2_1, VALUE_SERV_P2_2, VALUE_SERV_P2_3	;
	VALUE_SERV_P3_0, VALUE_SERV_P3_1, VALUE_SERV_P3_2, VALUE_SERV_P3_3	;
	
	KEY, TEMP_KEY, TEMP_KEY2, TEMP_KEY3

	BYTE_NUM, FLASH_COUNTER
	FLASH_ADDR_U, FLASH_ADDR_H, FLASH_ADDR_L

	MOV, XNUM_SPEED, XSPEED			; <---
	EMU_MODE, EMU_STATUS_SEQ_NUM		;
	STATUS_SEQ_NUM, STATUS_SEQ_NUM_TEMP	; 
	MAX_STEP_H, MAX_STEP_L			; MAX_STEP == NUM OF STEP!!!
	OFFSET_SEQ_H, OFFSET_SEQ_L		; OFFSET TO ADD TO FLASH_OFFSET

	ENDC


	CBLOCK 0x80		;TOC
	TOT_NUM_FBYTE_H, TOT_NUM_FBYTE_L 
	MAX_STEP_SEQ_0_H, MAX_STEP_SEQ_0_L, OFFSET_SEQ_0_H, OFFSET_SEQ_0_L
	MAX_STEP_SEQ_1_H, MAX_STEP_SEQ_1_L, OFFSET_SEQ_1_H, OFFSET_SEQ_1_L
	MAX_STEP_SEQ_2_H, MAX_STEP_SEQ_2_L, OFFSET_SEQ_2_H, OFFSET_SEQ_2_L
	MAX_STEP_SEQ_3_H, MAX_STEP_SEQ_3_L, OFFSET_SEQ_3_H, OFFSET_SEQ_3_L
	MAX_STEP_SEQ_4_H, MAX_STEP_SEQ_4_L, OFFSET_SEQ_4_H, OFFSET_SEQ_4_L
	MAX_STEP_SEQ_5_H, MAX_STEP_SEQ_5_L, OFFSET_SEQ_5_H, OFFSET_SEQ_5_L
	MAX_STEP_SEQ_6_H, MAX_STEP_SEQ_6_L, OFFSET_SEQ_6_H, OFFSET_SEQ_6_L
	MAX_STEP_SEQ_7_H, MAX_STEP_SEQ_7_L, OFFSET_SEQ_7_H, OFFSET_SEQ_7_L
	MAX_STEP_SEQ_8_H, MAX_STEP_SEQ_8_L, OFFSET_SEQ_8_H, OFFSET_SEQ_8_L
	MAX_STEP_SEQ_9_H, MAX_STEP_SEQ_9_L, OFFSET_SEQ_9_H, OFFSET_SEQ_9_L
	MAX_STEP_SEQ_10_H, MAX_STEP_SEQ_10_L, OFFSET_SEQ_10_H, OFFSET_SEQ_10_L
	MAX_STEP_SEQ_11_H, MAX_STEP_SEQ_11_L, OFFSET_SEQ_11_H, OFFSET_SEQ_11_L
	MAX_STEP_SEQ_12_H, MAX_STEP_SEQ_12_L, OFFSET_SEQ_12_H, OFFSET_SEQ_12_L
	MAX_STEP_SEQ_13_H, MAX_STEP_SEQ_13_L, OFFSET_SEQ_13_H, OFFSET_SEQ_13_L
	MAX_STEP_SEQ_14_H, MAX_STEP_SEQ_14_L, OFFSET_SEQ_14_H, OFFSET_SEQ_14_L
	MAX_STEP_SEQ_15_H, MAX_STEP_SEQ_15_L, OFFSET_SEQ_15_H, OFFSET_SEQ_15_L
	ENDC

	CBLOCK 0x100	; RAM Buffer for Flash Writing
	FLASH_BUFF
	ENDC



;       I/O ports
;------------------------------------------------------------
;       Serial comms.   :       PORTC <7:6>
;	Servo Output	:	PORTB <7:0>
;       Keys            :       PORTC <3:2>
;	LEDs		:	PORTC <5:4>
;------------------------------------------------------------



LED_GREEN	=	4
LED_RED		=	5
PORT_LED	=	PORTC
TRIS_LED	=	TRISC
#DEFINE	G_LED	PORT_LED, LED_GREEN
#DEFINE	R_LED	PORT_LED, LED_RED

;#DEFINE	DEBUG_PIN	PORTA, 4	; IF = 0 THEN EMULATION/PROGRAMMATION!!!

#DEFINE	SEQ_IN_0	PORTA, 4	;
#DEFINE	SEQ_TRIS_0	TRISA, 4	;
#DEFINE	SEQ_IN_1	PORTA, 5	;
#DEFINE	SEQ_TRIS_1	TRISA, 5	;
#DEFINE	SEQ_IN_2	PORTC, 0	;
#DEFINE	SEQ_TRIS_2	TRISC, 0	;
#DEFINE	SEQ_IN_3	PORTC, 1	;
#DEFINE	SEQ_TRIS_3	TRISC, 1	;

#DEFINE	NUM_OF_SERVO_CHANN	D'12'	; NUM_OF_SERVO_CHANN IS DIFFERENT TO NUM_OF_SERVO
#DEFINE	FLASH_INDEX_OFFSET	0x2100
#DEFINE	FLASH_OFFSET		(0x2100 + 0x0080)

#DEFINE	START_SPEED	D'1'	;; (PERIODO DI AGGIORNAMENTO INIZIALE ... X 20 ms)


#DEFINE	VALUE_SERV_0	VALUE_SERV_P1_0
#DEFINE	VALUE_SERV_1	VALUE_SERV_P1_1
#DEFINE	VALUE_SERV_2	VALUE_SERV_P1_2
#DEFINE	VALUE_SERV_3	VALUE_SERV_P1_3
#DEFINE	VALUE_SERV_4	VALUE_SERV_P1_4
#DEFINE	VALUE_SERV_5	VALUE_SERV_P1_5
#DEFINE	VALUE_SERV_6	VALUE_SERV_P1_6
#DEFINE	VALUE_SERV_7	VALUE_SERV_P1_7
#DEFINE	VALUE_SERV_8	VALUE_SERV_P2_0
#DEFINE	VALUE_SERV_9	VALUE_SERV_P2_1
#DEFINE	VALUE_SERV_10	VALUE_SERV_P2_2
#DEFINE	VALUE_SERV_11	VALUE_SERV_P2_3
#DEFINE	VALUE_SERV_12	VALUE_SERV_P3_0
#DEFINE	VALUE_SERV_13	VALUE_SERV_P3_1
#DEFINE	VALUE_SERV_14	VALUE_SERV_P3_2
#DEFINE	VALUE_SERV_15	VALUE_SERV_P3_3

#DEFINE	TOC_RAM		TOT_NUM_FBYTE_H		;
#DEFINE	TEMP_COUNTER_H	TOT_NUM_STEP_H		;
#DEFINE	TEMP_COUNTER_L	TOT_NUM_STEP_L		;

#DEFINE	MAX_NUM_OF_SEQ	D'16'	; NUM OF DIFFERENT SEQUENCES

	ORG	0x00
	GOTO	MAIN

;*********************************************************************
;
;	ROUTINE DI INTERRUPT
;

	ORG     0x08                    	; ROUTINE DI INTERRUPT
        GOTO    INTERRUPT       	;
;*****************************************************************
;*****************************************************************


;*****************************************************************
;*****************************************************************
;
; QUI CI SONO I FILE DI INCLUDE E DI MACRO!
;

	include "18fmacro.asm"		; Va definito sempre per primo
	include "18f_perf.asm"		;	
	include "18_Math.asm"		;
	include "ServoRoutines.asm"	;	
	include "ServoF18Extnd.asm"	;	
	include "18f_flash.asm"		;
	include "Keys18F.asm"		;
	
;
;*****************************************************************
;*****************************************************************



	

;***************************************************************
;
;	OPERAZIONI DA COMPIERE ALL'INTERRUPT
;
;***************************************************************

INTERRUPT:
	BTFSC	PIR1, RCIF		;
	CALL	DECODE			;
	
	BTFSC	PIR2, CCP2IF		;
	CALL	TIMER_UPDATE		;

        RETFIE	FAST			;




;****************************************************************************
;****************************************************************************
;
; TICK DI SISTEMA (Scatta ogni 50 ms)
;
;****************************************************************************
;****************************************************************************

TIMER_UPDATE:
	BCF	PIR2, CCP2IF		; CLEAR FLAG of COMPARE INTERRUPT 

	INCF	CINQUANTESIMI, F	; 1/50 sec!

	CALL	SERVO_UPDATE		;

	BTFSS	MOV, 0			;
	BRA	END_UPDATE		;

	MOVF	MAX_STEP_H, W		; TEST IF MAX_STEP = 0
	IORWF	MAX_STEP_L, W		; IF MAX_STEP = 0 THEN SKIP TO SEQ_NULL
	BZ	SEQ_NULL		; (NO STEP TO INCREMENT, NO TIME)
	
	MOVLW	0x00			; DECREMENT TIME_STEP
	DECF	TIME_STEP_L, F		;
	SUBWFB	TIME_STEP_H, F		;
	MOVF	TIME_STEP_H, W		; TEST IF ZERO
	IORWF	TIME_STEP_L, W		; SE <> 0 THEN SKIP TO END_UPDATE
	BNZ	END_UPDATE		; (NOTHING TO UPDATE)

	INFSNZ	STEP_COUNTER_L		; STEP COUNTER INCREMENT!
	INCF	STEP_COUNTER_H		;	

	MOVF	MAX_STEP_L, W		; IF STEP COUNTER == MAX_STEP
	SUBWF	STEP_COUNTER_L, W	; 
	BNZ	VALUE_UPDATE		; 

	MOVF	MAX_STEP_H, W		;
	SUBWF	STEP_COUNTER_H, W	; 
	BNZ	VALUE_UPDATE		; THEN

SEQ_NULL:
	CALL	SET_SEQ_START_PARAM	; RESET SEQUENCE PARAMETERS!

VALUE_UPDATE:
	CALL	READ_STEP_FROM_FLASH	;
		
END_UPDATE:
	MOVLW	D'50'			;
	CPFSEQ	CINQUANTESIMI		; SE CINQUANTESIMI = 50 ALLORA SKIP IL RETURN
	RETURN				; 
	CLRF	CINQUANTESIMI		;
	RETURN				; 
	
;****************************************************************************
;****************************************************************************

MAIN:
	CALL	SETPORTS		;
	CALL	VAR_INIT		;

HALLO:      
	BSF	G_LED			;
	MILLISECONDI	D'500'		; <----------------------------
	BCF	G_LED			;
	BSF	R_LED			;
	MILLISECONDI	D'500'		; <----------------------------
	BSF	G_LED			;
	BCF	R_LED			;
	MILLISECONDI	D'500'		; <----------------------------
	BCF	G_LED			;

					;; ABILITAZIONE COMUNICAZIONE SERIALE
	BSF     RCSTA,SPEN      	;; RX/TX MODULE ACTIVED
	CLRF    RCREG			;;
	BSF	PIE1, RCIE		;; RX INTERRUPT ON
	BSF	INTCON, GIE		;

MAINLOOP:				;
	CALL	WAITFORKEY		; <----------------------------
					;
	CALL	STATUS_SEQ_NUM_READ	; SEQUENCE STATUS NUMBER READING
					;
	GOTO 	MAINLOOP		;

KEY_2_Routine				;
	BTFSS	MOV, 0			;
	GOTO	TIMER_MOV_ON		;
	RETURN				;	

KEY_2_PRESS_Routine			;
	RETURN				;	

KEY_3_Routine				;
	BTFSC	MOV, 0			;
	GOTO	TIMER_MOV_OFF		;
	RETURN				;

KEY_3_PRESS_Routine			; AUTO-ZERO SEQUENCE
	BTFSC	MOV, 0			;
	RETURN				;	
	TabSetting	FLASH_OFFSET	;
	CALL	READ_STEP_FROM_FLASH	;
	CALL	TIMER_ON		;
	BSF	R_LED			;
	MILLISECONDI	D'1000'		;
	BCF	R_LED			;
	CALL	TIMER_OFF		;
	RETURN				;	

;-----------------------------------------------------


TIMER_ON:
	BSF	G_LED			;
	CLRF	TMR3L			;
	CLRF	TMR3L			;
	BCF	PIR2, CCP2IF		;
	BSF	PIE2, CCP2IE		; SETTING INTERRUPT
	BSF	T3CON, TMR3ON		; START TIMER3
	RETURN

TIMER_OFF:
	BCF	G_LED			;
	BCF	PIR2, CCP2IF		;
	BCF	PIE2, CCP2IE		; RESETTING INTERRUPT
	BCF	T3CON, TMR3ON		; START TIMER3
	BCF	PIR2, CCP2IF		;
	RETURN


TIMER_MOV_ON:
	CALL	TIMER_ON		;
	CALL	SET_SEQ_START_PARAM	; RESET SEQUENCE PARAMETERS!
	CALL	READ_STEP_FROM_FLASH	;
	BSF	R_LED			;
	SETF	MOV			; "MOV" = 1
	RETURN				;

TIMER_MOV_OFF:
	CALL	TIMER_OFF		;
	BCF	R_LED			;
	CLRF	MOV			; "MOV" = 0
	RETURN


SET_SEQ_START_PARAM			; SET SEQUENCE PARAMETER ON THE BASE OF STATUS_SEQ_NUM
	CLRF	STEP_COUNTER_H		; STEP_COUNTER = 0
	CLRF	STEP_COUNTER_L		;
					;
	LFSR	0, MAX_STEP_SEQ_0_H	; SETTING RAM POINTER TO SEQ 0
					;
	MOVF	STATUS_SEQ_NUM, W	;
	BCF	STATUS, C		;
	RLCF	WREG, F			; STATUS_SEQ_NUM X 2
	RLCF	WREG, F			; STATUS_SEQ_NUM X 4
	ADDWF	FSR0L, F		;
	BTFSC	STATUS, C		;
	INCF	FSR0H, F		; SETTING RAM POINTER TO SEQ n
					;
	MOVF	POSTINC0, W		;
	MOVWF	MAX_STEP_H		;
	MOVF	POSTINC0, W		;
	MOVWF	MAX_STEP_L		; MAX_STEP SELECTED!
	MOVF	POSTINC0, W		;
	MOVWF	OFFSET_SEQ_H		;
	MOVF	POSTINC0, W		;
	MOVWF	OFFSET_SEQ_L		; OFFSET SELECTED!
					;
	TabSetting FLASH_OFFSET		; SETTING FLASH POINTER AT SEQ 0
	MOVF	OFFSET_SEQ_L, W		;
	ADDWF	TBLPTRL, F		;
	MOVF	OFFSET_SEQ_H, W		;
	ADDWFC	TBLPTRH, F		;
	MOVLW	0X00			;
	ADDWFC	TBLPTRU, F		; SETTING FLASH POINTER AT SEQ n
	RETURN				;


LOAD_TOC:					; LOAD TOC: FLASH --> RAM
	TabSetting FLASH_INDEX_OFFSET		; SETTING FLASH POINTER
	LFSR	0, TOC_RAM			; SETTING RAM POINTER
	MOVLW	(MAX_NUM_OF_SEQ*D'4')+D'2'	;
	MOVWF	TOT_NUM_STEP_L			;
TOC_LOOP					;
	TBLRD*+					;
	MOVF	TABLAT, W			;
	MOVWF	POSTINC0			;
	;---					;
	DECFSZ	TOT_NUM_STEP_L, F		;
	BRA	TOC_LOOP			;
	RETURN					;


SAVE_TOC:					; SAVE TOC: RAM --> FLASH
	TabSetting (FLASH_INDEX_OFFSET - D'8')	; OFFESET ADJUST! (FOR BUFFER LOADING SHIFT)
	LFSR	0, TOC_RAM			; SETTING RAM POINTER
	MOVLW	(MAX_NUM_OF_SEQ*D'4')+D'8'	; NUM OF BYTE OF TOC (IT MUST BE MULTIPLE OF 8)
	MOVWF	BYTE_NUM			; 
	CALL	WRITE_FLASH_NO_ADDR_NO_OFFSET	; FLASH ROUTINE
	RETURN					;




	ORG	FLASH_INDEX_OFFSET	; TOC
	DB	D'0',	D'224'		; NUM OF SEQUENCE FLASH BYTES !!! FLASH_INDEX (TOC) NOT INCLUDED
	DB	D'0',	D'8'		; SEQ 0 STEPS
	DB	D'0',	D'0'		; SEQ 0 OFFSET
	DB	D'0',	D'2'		; SEQ 1 STEPS
	DB	D'0',	D'112'		; SEQ 1 OFFSET
	DB	D'0',	D'2'		; SEQ 2 STEPS
	DB	D'0',	D'140'		; SEQ 2 OFFSET
	DB	D'0',	D'2'		; SEQ 3 STEPS
	DB	D'0',	D'168'		; SEQ 3 OFFSET
	DB	D'0',	D'2'		; SEQ 4 STEPS
	DB	D'0',	D'196'		; SEQ 4 OFFSET
	DB	D'0',	D'0'		; SEQ 5 STEPS
	DB	D'0',	D'0'		; SEQ 5 OFFSET
	DB	D'0',	D'0'		; SEQ 6 STEPS
	DB	D'0',	D'0'		; SEQ 6 OFFSET
	DB	D'0',	D'0'		; SEQ 7 STEPS
	DB	D'0',	D'0'		; SEQ 7 OFFSET
	DB	D'0',	D'0'		; SEQ 8 STEPS
	DB	D'0',	D'0'		; SEQ 8 OFFSET
	DB	D'0',	D'0'		; SEQ 9 STEPS
	DB	D'0',	D'0'		; SEQ 9 OFFSET
	DB	D'0',	D'0'		; SEQ 10 STEPS
	DB	D'0',	D'0'		; SEQ 10 OFFSET
	DB	D'0',	D'0'		; SEQ 11 STEPS
	DB	D'0',	D'0'		; SEQ 11 OFFSET
	DB	D'0',	D'0'		; SEQ 12 STEPS
	DB	D'0',	D'0'		; SEQ 12 OFFSET
	DB	D'0',	D'0'		; SEQ 13 STEPS
	DB	D'0',	D'0'		; SEQ 13 OFFSET
	DB	D'0',	D'0'		; SEQ 14 STEPS
	DB	D'0',	D'0'		; SEQ 14 OFFSET
	DB	D'0',	D'0'		; SEQ 15 STEPS
	DB	D'0',	D'0'		; SEQ 15 OFFSET

	ORG	FLASH_OFFSET
	DB	D'0',	D'0'		; SEQ 0 STEPS #0
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'30'
	DB	D'10',	D'0'		; SEQ 0 STEPS #1
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'10'
	DB	D'0',	D'30'
	DB	D'20',	D'0'		; SEQ 0 STEPS #2
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'20'
	DB	D'0',	D'30'
	DB	D'30',	D'0'		; SEQ 0 STEPS #3
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'30'
	DB	D'0',	D'30'
	DB	D'40',	D'0'		; SEQ 0 STEPS #4
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'40'
	DB	D'0',	D'30'
	DB	D'50',	D'0'		; SEQ 0 STEPS #5
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'50'
	DB	D'0',	D'30'
	DB	D'60',	D'0'		; SEQ 0 STEPS #6
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'60'
	DB	D'0',	D'30'
	DB	D'70',	D'0'		; SEQ 0 STEPS #7
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'70'
	DB	D'0',	D'30'
	DB	D'0',	D'0'	;<---	; SEQ 1 STEPS #0
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'30'
	DB	D'200',	D'0'	;<---	; SEQ 1 STEPS #1
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'30'
	DB	D'0',	D'0'	;<---	; SEQ 2 STEPS #0
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'60'
	DB	D'100',	D'0'	;<---	; SEQ 2 STEPS #1
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'60'
	DB	D'0',	D'0'	;<---	; SEQ 3 STEPS #0
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'120'
	DB	D'200',	D'0'	;<---	; SEQ 3 STEPS #1
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'120'
	DB	D'0',	D'0'	;<---	; SEQ 4 STEPS #0
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'30'
	DB	D'20',	D'0'	;<---	; SEQ 4 STEPS #1
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'30'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'
	DB	D'0',	D'0'



	END

 
